SystemOrganization addCategory: #'Croquet-Islands'!

IslandWriter subclass: #TIslandWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Islands'!

!TIslandWriter class methodsFor: 'accessing' stamp: 'ar 6/17/2005 18:57'!
archiveVersionID
	^UUID fromString: '356c78ad-0b24-874c-ac2b-0bf957eced0f'! !

!TIslandWriter class methodsFor: 'accessing' stamp: 'ar 6/17/2005 18:58'!
objectVersionID
	^UUID fromString: 'd94b7ef6-544c-4449-9dc5-f090ca42cea8'! !

!TIslandWriter methodsFor: 'exporting' stamp: 'ar 6/17/2005 18:54'!
exportFarRef: farRef
	"Check if this is a global"
	| island globalName |
	island := farRef island.
	globalName := island globalNameAt: farRef ifAbsent:[nil].
	globalName ifNil:[^self exportProhibited: farRef].
	dataStream nextPut: CodeGlobalRef.
	self export: farRef island uid.
	self export: globalName.
	self export: (farRef send: #class) name.
! !

IslandReader subclass: #TIslandReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Islands'!

!TIslandReader class methodsFor: 'class initialization' stamp: 'ar 6/17/2005 19:00'!
archiveVersionID
	^TIslandWriter archiveVersionID! !

!TIslandReader class methodsFor: 'class initialization' stamp: 'ar 6/17/2005 19:00'!
objectVersionID
	^TIslandWriter objectVersionID! !

!TIslandReader methodsFor: 'importing' stamp: 'ar 6/17/2005 18:53'!
importGlobalRef
	| className uid globalName |
	uid := self importNext.
	globalName := self importNext.
	className := self importNext.
	uid. globalName. className.
	^nil
! !

!TIslandReader methodsFor: 'importing' stamp: 'ar 6/17/2005 18:53'!
importTForm
	| extent fileName bMM bSF ext form pngStream pngForm |
	fileName := self importNext.
	extent := self importNext.
	bMM := self importNext.
	bSF := self importNext.
	ext := self importNext.
	archive ifNil:[
		pngForm := Form extent: extent depth: 32.
		pngForm fillWhite.
	] ifNotNil:[
		progressBar ifNotNil:[progressBar value: 'Loading ', fileName].
		pngStream := (archive memberNamed: fileName) contentStream binary.
		pngForm := (PNGReadWriter on: pngStream) nextImage.
	].
	form := TForm new initialize: fileName form: pngForm mipmap: bMM shrinkFit: bSF extension: ext.
	^form
! !

Object subclass: #RecurseWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Islands'!

!RecurseWorld commentStamp: 'das 4/3/2006 02:08' prior: 0!
RecurseWorld is used to illustrate the construction and population of a new Island. It is designed to be linked with the SimpleWorld Island.!

!RecurseWorld class methodsFor: 'as yet unclassified' stamp: 'ar 3/9/2006 17:55'!
islandID
	^TObjectID readHexFrom: 'a45a848e08ee1328b509b5976f3a86ea'! !

!RecurseWorld methodsFor: 'initialize' stamp: 'das 7/5/2006 13:21'!
initialize

	| frame space cube cube2 portal win number count |

	space := TSpace new.
	space color: (VectorColor r:0.2 g:1.0 b:1.0 a:1.0).
	space registerGlobal:#recurseSpace.
	TLight makeLights: space.
	cube := TCube new.
	space addChild: cube.
	50 timesRepeat:[
		cube2 := TCube new.
		frame := TDemoFish new.
		frame target: cube.
		frame contents: cube2.
		frame translation:((20-(40 atRandom))@(20-(40 atRandom))@(20-(40 atRandom))).
		space addChild: frame.
		frame addRotationAroundX: 360 atRandom.
		frame addRotationAroundY: 360 atRandom.
		frame addRotationAroundZ: 360 atRandom.
	].
	25 timesRepeat:[
		frame := TSpinTest new.
		space addChild: frame.
		frame translation:((10-(20 atRandom))@(10-(20 atRandom))@(10-(20 atRandom))).
		frame addRotationAroundX: 360 atRandom.
		frame addRotationAroundY: 360 atRandom.
		frame addRotationAroundZ: 360 atRandom.
	].

	number := 4.
	count := 1.
	1 to: number do:[:i |
		1 to: number do:[:j |
			1 to: number do:[:k|
				cube := TDragCube new.
				cube rotationAroundY:15.
				cube translation:((i-1-(number/2.0))@(j-1-(number/2.0))@(k-1-(number/2.0))).
				cube setColor: (VectorColor r:number-i/number asFloat g:number-j/number asFloat b:number-k/number asFloat a:1.0).
				cube objectName: count.
				count := count+1.
				space addChild: cube.
			].
		].
	].


	win := TWindow new.
	win translation: 0@0@15.
	space addChild: win.

	portal := TPortal new.
	portal translation: 0@0@0.
	portal registerGlobal:#portal1.
	portal extent:5@5.
	win rotationAroundY:180.
	win contents: portal.

! !

Object subclass: #SystemOverlay
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Islands'!

!SystemOverlay methodsFor: 'initialize-release' stamp: 'das 7/10/2005 20:27'!
initialize

	^ TSystemSpace new inPortal.
! !

Object subclass: #SimpleWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants'
	category: 'Croquet-Islands'!

!SimpleWorld commentStamp: 'das 4/3/2006 02:08' prior: 0!
SimpleWorld is used to illustrate the construction and population of a new Island. It is designed to be linked with the RecurseWorld Island.!

!SimpleWorld class methodsFor: 'instance creation' stamp: 'ar 3/9/2006 17:54'!
islandID
	^TObjectID readHexFrom: '571ba0e67028545ff46eb6989cc43ebc'! !

!SimpleWorld methodsFor: 'initialize' stamp: 'BM 4/12/2013 18:42'!
initialize

	| space portal sky win p3 pic |

	space := TSpace new.
	space registerGlobal:#masterSpace.
	self makeLights: space.
	self makeFloor:space fileName:'lawn.bmp'.
	self makeKay: space.
	self makePyramid: space.
	self makeCube: space.

	win := TWindow new.
	win translation: 0@0@-20.
	space addChild: win.

	portal := TPortal new.
	portal registerGlobal:#portal1.
	portal extent:5@5.
	win contents: portal.

	sky := TSkyBox new initializeWithFileName: 'JUL'.
	space addChild: sky.
	sky step. "get going"

	p3 := TPortal3D new.
	p3 translation: 10@-1@10.
	space addChild: p3.
	p3 registerGlobal:#portal3D.

	TScrollBox3D new initializeWithContents: p3.

	pic := TRotTexture
				new initializeWithFileName: 'KAY.bmp'
				mipmap: true
				shrinkFit: false.
	pic translation:0@0@-2.
	space addChild: pic.! !

!SimpleWorld methodsFor: 'initialize' stamp: 'BM 4/12/2013 18:55'!
makeCube: sp
	| matNorm spinner cube |
	cube := TCube new.
	matNorm := TMaterial new.
	matNorm ambientColor: #(1.0 0.2 0 0).
	cube material: matNorm.
	cube scale: 5.0.

	spinner := TSpinner new.
	spinner translationX: -10 y:0 z: -10.
	spinner contents: cube.
	sp addChild: spinner.
! !

!SimpleWorld methodsFor: 'initialize' stamp: 'das 7/5/2006 13:21'!
makeFloor: space fileName: txtrName

	| floor txtr |

	txtr := TTexture new initializeWithFileName: txtrName
				mipmap: true
				shrinkFit: false.
	txtr uvScale: 8.0@8.0.

	floor := TCube new.
	floor extentX:80 y:0.5 z: 80.
	floor translationX: 0 y: -6.0 z: 0.0.
	floor texture: txtr.
	floor objectName: 'floor' copy.
	space addChild: floor.

! !

!SimpleWorld methodsFor: 'initialize' stamp: 'das 7/8/2006 15:25'!
makeKay: sp
	| env pic win tframe |
	pic := TTexture
				new initializeWithFileName: 'KAY.bmp'
				mipmap: true
				shrinkFit: false.

	env := TTexture
				new initializeWithFileName: 'SkyBoxJULRT.bmp' 
				mipmap: true
				shrinkFit: false.

	tframe := TWaves initializeWithSize: 20@20.
	tframe texture: pic.
	tframe envTexture: env.
	tframe divisions:3@3.
	win := TWindow new.
	win contents: tframe.
	win translationX: 7 y: 0.0 z: -10.0.
	sp addChild: win.

! !

!SimpleWorld methodsFor: 'initialize' stamp: 'das 4/1/2006 13:52'!
makeLights: space

	| light |

"warm light in northwest corner."
	light := TLight new.
	light ambientColor: #(0.3 0.4 0.5 0.6).
	light diffuseColor: #(0.48 0.35 0.4 0.6).
	light specularColor: #(0.3 0.23 0.2 0.5).
	light rotationAroundY: -130.
	light addRotationAroundX: 120.
	space addChild: light.

"cool light diagonally opposite."
	light := TLight new.
	light ambientColor: #(0.1 0.1 0.1 0.1).
	light diffuseColor: #(0.4 0.35 0.48 0.6).
	light specularColor: #(0.2 0.23 0.3 0.5).
	light rotationAroundY: 132.
	light addRotationAroundX: 120.
	space addChild: light.

" fainter green light in third corner."
	light := TLight new.
	light ambientColor: #(0.1 0.1 0.1 0.1).
	light diffuseColor: #(0.1 0.23 0.1 0.4).
	light specularColor: #(0.3 0.2 0.3 0.3).
	light rotationAroundY: 42.
	light addRotationAroundX: 120.
	space addChild: light.

"and another opposite it"
	light := TLight new.
	light ambientColor: #(0.1 0.1 0.1 0.1).
	light diffuseColor: #(0.1 0.23 0.1 0.4).
	light specularColor: #(0.4 0.3 0.2 0.2).
	light rotationAroundY: -42.
	light addRotationAroundX: 120.
	space addChild: light.
! !

!SimpleWorld methodsFor: 'initialize' stamp: 'das 4/1/2006 13:51'!
makePyramid: sp
	| pyr matNorm spinner |
	pyr := TSierpinski new.
	matNorm := TMaterial new.
	matNorm ambientColor: #(0.9 0.6 0.5 0.5).
	matNorm diffuseColor: #(0.9 0.6 0.5 0.5).
	pyr material: matNorm.
	pyr scale: 5.0.
	pyr depth: 3.

	spinner := TSpinner new.
	spinner translationX: -10 y:0 z: -10.
	spinner contents: pyr.
	sp addChild: spinner.
! !

!SimpleWorld methodsFor: 'windows' stamp: 'ar 2/7/2006 16:55'!
makeWidget: uri scale: scl

	| frame fileName |
	fileName := FileDirectory pathFromURI: uri.
	frame := (TLoad3DSMax new initializeWithFileName: fileName scale: scl) frame.
	frame boundsDepth: 1.
	frame initBounds.
	frame do:[ :tf |
		tf isMesh ifTrue:[ tf materialList do:[ :ml |
			ml ambientColor: #(0.2 0.5 1.0 0.8).
			ml diffuseColor:#(0.2 0.5 1.0 0.8).
			ml textureMode: GLModulate.
		]].
		tf checkAlpha.
	].
	^frame! !

TSpace subclass: #TSystemSpace
	instanceVariableNames: 'corners cornerVector views'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Islands'!

!TSystemSpace methodsFor: 'initialize' stamp: 'das 7/10/2005 20:22'!
bounds: bnds! !

!TSystemSpace methodsFor: 'events' stamp: 'das 5/23/2006 11:45'!
eventMask

" eat all of the spurious events - these would normally go to the avatar, but the overlay is not handled in quite the same way "
	^ EventPointerOver bitOr: (EventPointerDown bitOr: EventKeyboard).! !

!TSystemSpace methodsFor: 'initialize' stamp: 'das 7/5/2006 13:26'!
initialize
	| light frame sphere mat |
	super initialize.
	light := TLight new.
	self addChild: light.
true ifTrue:[^self].
	corners := OrderedCollection new.
	4 timesRepeat:[
		frame := TSpinTest new.
		sphere := TSphere new.
mat := TMaterial new.
mat color: #(0.3 0.8 0.3 1).
		sphere material: mat.
		sphere radius: 0.5.
		frame addChild: sphere.
		self addChild: frame.
		frame translation:((10-(20 atRandom))@(10-(20 atRandom))@(-5-(20 atRandom))).
		frame addRotationAroundX: 360 atRandom.
		frame addRotationAroundY: 360 atRandom.
		frame addRotationAroundZ: 360 atRandom.
		corners add: frame.
	].
! !

!TSystemSpace methodsFor: 'initialize' stamp: 'das 3/2/2006 16:01'!
rearrange: ogl

	frameChildren ifNotNil:[
		frameChildren do:[ :fc | fc rearrange: ogl].].
"corners ifNil:[^self].
	cornerVector ~= ogl camera cornerVector ifTrue:[
		cornerVector := ogl camera cornerVector.
		vec := cornerVector*8.
		(corners at:1) translation: vec.
		(corners at:2) translation: vec x@ vec y negated@vec z.
		(corners at:3) translation: vec x negated@vec y negated@vec z.
		(corners at:4) translation: vec x negated@vec y@vec z.
	]."! !

!TSystemSpace methodsFor: 'render' stamp: 'das 7/10/2005 15:26'!
renderClearBounds: ogl

" do nothing "! !

TTexture subclass: #TRotTexture
	instanceVariableNames: 'angle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Islands'!

!TRotTexture methodsFor: 'as yet unclassified' stamp: 'das 7/8/2006 15:22'!
initialize

	super initialize.
	angle := 0.! !

!TRotTexture methodsFor: 'as yet unclassified' stamp: 'das 7/8/2006 17:10'!
spinTexture

	angle := angle +1.
	angle >= 360 ifTrue:[angle := 0].
	self uvAngle: angle.
	self uvOffset:0.01@0.01*angle.
	self uvScale:1@1*(angle/60.0).
	(self future:100) spinTexture.
! !

!TRotTexture methodsFor: 'as yet unclassified' stamp: 'das 7/8/2006 15:25'!
start

	self spinTexture.! !
